TarArchiveInputStream
Date: 2017-02-08

org.apache.commons.compress.archivers.tar

## Class TarArchiveInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.compress.archivers.ArchiveInputStream
    - - org.apache.commons.compress.archivers.tar.TarArchiveInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class TarArchiveInputStream
      extends ArchiveInputStream

  The TarInputStream reads a UNIX tar archive as an InputStream. methods are provided to position at each successive entry in the archive, and the read each entry as a normal input stream using read().

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TarArchiveInputStream(java.io.InputStream is)` Constructor for TarInputStream.
    `TarArchiveInputStream(java.io.InputStream is, int blockSize)` Constructor for TarInputStream.
    `TarArchiveInputStream(java.io.InputStream is, int blockSize, int recordSize)` Constructor for TarInputStream.
    `TarArchiveInputStream(java.io.InputStream is, int blockSize, int recordSize, java.lang.String encoding)` Constructor for TarInputStream.
    `TarArchiveInputStream(java.io.InputStream is, int blockSize, java.lang.String encoding)` Constructor for TarInputStream.
    `TarArchiveInputStream(java.io.InputStream is, java.lang.String encoding)` Constructor for TarInputStream.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Get the available data that can be read from the current entry in the archive.
    `boolean` | `canReadEntryData(ArchiveEntry ae)` Whether this class is able to read the given entry.
    `void` | `close()` Closes this stream.
    `TarArchiveEntry` | `getCurrentEntry()` Get the current TAR Archive Entry that this input stream is processing
    `protected byte[]` | `getLongNameData()` Get the next entry in this tar archive as longname data.
    `ArchiveEntry` | `getNextEntry()` Returns the next Archive Entry in this Stream.
    `TarArchiveEntry` | `getNextTarEntry()` Get the next entry in this tar archive.
    `int` | `getRecordSize()` Get the record size being used by this stream's buffer.
    `protected boolean` | `isAtEOF()`
    `protected boolean` | `isEOFRecord(byte[] record)` Determine if an archive record indicate End of Archive.
    `void` | `mark(int markLimit)` Since we do not support marking just yet, we do nothing.
    `boolean` | `markSupported()` Since we do not support marking just yet, we return false.
    `static boolean` | `matches(byte[] signature, int length)` Checks if the signature matches what is expected for a tar file.
    `int` | `read(byte[] buf, int offset, int numToRead)` Reads bytes from the current tar archive entry.
    `protected byte[]` | `readRecord()` Read a record from the input stream and return the data.
    `void` | `reset()` Since we do not support marking just yet, we do nothing.
    `protected void` | `setAtEOF(boolean b)`
    `protected void` | `setCurrentEntry(TarArchiveEntry e)`
    `long` | `skip(long n)` Skips over and discards `n` bytes of data from this input stream.

    - ### Methods inherited from class org.apache.commons.compress.archivers.ArchiveInputStream

      `count, count, getBytesRead, getCount, pushedBackBytes, read`

    - ### Methods inherited from class java.io.InputStream

      `read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TarArchiveInputStream

          public TarArchiveInputStream(java.io.InputStream is)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use

    - #### TarArchiveInputStream

          public TarArchiveInputStream(java.io.InputStream is,
                               java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveInputStream

          public TarArchiveInputStream(java.io.InputStream is,
                               int blockSize)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use

    - #### TarArchiveInputStream

          public TarArchiveInputStream(java.io.InputStream is,
                               int blockSize,
                               java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveInputStream

          public TarArchiveInputStream(java.io.InputStream is,
                               int blockSize,
                               int recordSize)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use

    - #### TarArchiveInputStream

          public TarArchiveInputStream(java.io.InputStream is,
                               int blockSize,
                               int recordSize,
                               java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `is` - the input stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

  - ### Method Detail

    - #### close

          public void close()
                     throws java.io.IOException

      Closes this stream. Calls the TarBuffer's close() method.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.InputStream`
      Throws:
        `java.io.IOException` - on error

    - #### getRecordSize

          public int getRecordSize()

      Get the record size being used by this stream's buffer.
      Returns:
        The TarBuffer record size.

    - #### available

          public int available()
                        throws java.io.IOException

      Get the available data that can be read from the current entry in the archive. This does not indicate how much data is left in the entire archive, only in the current entry. This value is determined from the entry's size header field and the amount of data already read from the current entry. Integer.MAX_VALUE is returned in case more than Integer.MAX_VALUE bytes are left in the current entry in the archive.
      Overrides:
        `available` in class `java.io.InputStream`
      Returns:
        The number of available bytes for the current entry.
      Throws:
        `java.io.IOException` - for signature

    - #### skip

          public long skip(long n)
                    throws java.io.IOException

      Skips over and discards `n` bytes of data from this input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly `0`. This may result from any of a number of conditions; reaching end of file or end of entry before `n` bytes have been skipped; are only two possibilities. The actual number of bytes skipped is returned. If `n` is negative, no bytes are skipped.
      Overrides:
        `skip` in class `java.io.InputStream`
      Parameters:
        `n` - the number of bytes to be skipped.
      Returns:
        the actual number of bytes skipped.
      Throws:
        `java.io.IOException` - if some other I/O error occurs.

    - #### markSupported

          public boolean markSupported()

      Since we do not support marking just yet, we return false.
      Overrides:
        `markSupported` in class `java.io.InputStream`
      Returns:
        False.

    - #### mark

          public void mark(int markLimit)

      Since we do not support marking just yet, we do nothing.
      Overrides:
        `mark` in class `java.io.InputStream`
      Parameters:
        `markLimit` - The limit to mark.

    - #### reset

          public void reset()

      Since we do not support marking just yet, we do nothing.
      Overrides:
        `reset` in class `java.io.InputStream`

    - #### getNextTarEntry

          public TarArchiveEntry getNextTarEntry()
                                          throws java.io.IOException

      Get the next entry in this tar archive. This will skip over any remaining data in the current entry, if there is one, and place the input stream at the header of the next entry, and read the header and instantiate a new TarEntry from the header bytes and return that entry. If there are no more entries in the archive, null will be returned to indicate that the end of the archive has been reached.
      Returns:
        The next TarEntry in the archive, or null.
      Throws:
        `java.io.IOException` - on error

    - #### getLongNameData

          protected byte[] getLongNameData()
                                    throws java.io.IOException

      Get the next entry in this tar archive as longname data.
      Returns:
        The next entry in the archive as longname data, or null.
      Throws:
        `java.io.IOException` - on error

    - #### isEOFRecord

          protected boolean isEOFRecord(byte[] record)

      Determine if an archive record indicate End of Archive. End of archive is indicated by a record that consists entirely of null bytes.
      Parameters:
        `record` - The record data to check.
      Returns:
        true if the record data is an End of Archive

    - #### readRecord

          protected byte[] readRecord()
                               throws java.io.IOException

      Read a record from the input stream and return the data.
      Returns:
        The record data or null if EOF has been hit.
      Throws:
        `java.io.IOException` - on error

    - #### getNextEntry

          public ArchiveEntry getNextEntry()
                                    throws java.io.IOException

      Returns the next Archive Entry in this Stream.
      Specified by:
        `getNextEntry` in class `ArchiveInputStream`
      Returns:
        the next entry, or `null` if there are no more entries
      Throws:
        `java.io.IOException` - if the next entry could not be read

    - #### read

          public int read(byte[] buf,
                 int offset,
                 int numToRead)
                   throws java.io.IOException

      Reads bytes from the current tar archive entry. This method is aware of the boundaries of the current entry in the archive and will deal with them as if they were this stream's start and EOF.
      Overrides:
        `read` in class `java.io.InputStream`
      Parameters:
        `buf` - The buffer into which to place bytes read.
        `offset` - The offset at which to place bytes read.
        `numToRead` - The number of bytes to read.
      Returns:
        The number of bytes read, or -1 at EOF.
      Throws:
        `java.io.IOException` - on error

    - #### canReadEntryData

          public boolean canReadEntryData(ArchiveEntry ae)

      Whether this class is able to read the given entry.

      May return false if the current entry is a sparse file.

      Overrides:
        `canReadEntryData` in class `ArchiveInputStream`
      Parameters:
        `ae` - the entry to test
      Returns:
        This implementation always returns true.

    - #### getCurrentEntry

          public TarArchiveEntry getCurrentEntry()

      Get the current TAR Archive Entry that this input stream is processing
      Returns:
        The current Archive Entry

    - #### setCurrentEntry

          protected final void setCurrentEntry(TarArchiveEntry e)

    - #### isAtEOF

          protected final boolean isAtEOF()

    - #### setAtEOF

          protected final void setAtEOF(boolean b)

    - #### matches

          public static boolean matches(byte[] signature,
                        int length)

      Checks if the signature matches what is expected for a tar file.
      Parameters:
        `signature` - the bytes to check
        `length` - the number of bytes to check
      Returns:
        true, if this stream is a tar archive stream, false otherwise